--
-- Tractor hours
--
-- @author  Jack
-- @date  01/05/09
--
-- Copyright (C) Jack

hours_schlepper = {};

function hours_schlepper.prerequisitesPresent(specializations)
    return true;
end;

function hours_schlepper:load(xmlFile)

self.GetSaveAttributesAndNodes = self.getSaveAttributesAndNodes;
self.LoadFromAttributesAndNodes = self.loadFromAttributesAndNodes;
self.setstd = SpecializationUtil.callSpecializationsFunction("setstd");

-- its a test for a new trigger
    self.stdh = 10000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000;

    self:setstd(0);
	
	local wheelAreaCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.wheelAreas#count"), 0.0);
	self.wheelArea = {};
	for i=1, wheelAreaCount do
		self.wheelArea[i] = {};
		self.wheelArea[i].start = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wheelAreas.wheelArea"..tostring(i).."#start"));
		self.wheelArea[i].width = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wheelAreas.wheelArea"..tostring(i).."#width"));
		self.wheelArea[i].height = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wheelAreas.wheelArea"..tostring(i).."#height"));
	end;
	local translationPartNodeMain = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPartMain#index"));
    if translationPartNodeMain ~= nil then
        self.translationPartMain = {};
        self.translationPartMain.node = translationPartNodeMain;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartMain#minTrans"));
        self.translationPartMain.minTrans = {};
        self.translationPartMain.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartMain.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartMain.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartMain#maxTrans"));
        self.translationPartMain.maxTrans = {};
        self.translationPartMain.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartMain.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartMain.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartMain.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartMain#transTime"), 2)*1000;
        self.translationPartMain.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartMain#touchTransLimit"), 10);
    end;
	local translationPartNodeLeft = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPartLeft#index"));
    if translationPartNodeLeft ~= nil then
        self.translationPartLeft = {};
        self.translationPartLeft.node = translationPartNodeLeft;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartLeft#minTrans"));
        self.translationPartLeft.minTrans = {};
        self.translationPartLeft.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartLeft.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartLeft.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartLeft#maxTrans"));
        self.translationPartLeft.maxTrans = {};
        self.translationPartLeft.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartLeft.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartLeft.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartLeft.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartLeft#transTime"), 2)*1000;
        self.translationPartLeft.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartLeft#touchTransLimit"), 10);
    end;
	local translationPartNodeRight = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.translationPartRight#index"));
    if translationPartNodeRight ~= nil then
        self.translationPartRight = {};
        self.translationPartRight.node = translationPartNodeRight;
        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartRight#minTrans"));
        self.translationPartRight.minTrans = {};
        self.translationPartRight.minTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartRight.minTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartRight.minTrans[3] = Utils.getNoNil(z, 0);

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.translationPartRight#maxTrans"));
        self.translationPartRight.maxTrans = {};
        self.translationPartRight.maxTrans[1] = Utils.getNoNil(x, 0);
        self.translationPartRight.maxTrans[2] = Utils.getNoNil(y, 0);
        self.translationPartRight.maxTrans[3] = Utils.getNoNil(z, 0);

        self.translationPartRight.transTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartRight#transTime"), 2)*1000;
        self.translationPartRight.touchTransLimit = Utils.getNoNil(getXMLString(xmlFile, "vehicle.translationPartRight#touchTransLimit"), 10);
    end;
	
    local rotationPartNodeHydraulicLower = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartHydraulicLower#index"));
    if rotationPartNodeHydraulicLower ~= nil then
        self.rotationPartHydraulicLower = {};
        self.rotationPartHydraulicLower.node = rotationPartNodeHydraulicLower;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartHydraulicLower#minRot"));
        self.rotationPartHydraulicLower.minRot = {};
        self.rotationPartHydraulicLower.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartHydraulicLower.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartHydraulicLower.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartHydraulicLower#maxRot"));
        self.rotationPartHydraulicLower.maxRot = {};
        self.rotationPartHydraulicLower.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartHydraulicLower.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartHydraulicLower.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartHydraulicLower.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartHydraulicLower#rotTime"), 2)*1000;
        self.rotationPartHydraulicLower.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartHydraulicLower#touchRotLimit"), 10));
    end;
	
    local rotationPartNodeHydraulicUpper = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.rotationPartHydraulicUpper#index"));
    if rotationPartNodeHydraulicUpper ~= nil then
        self.rotationPartHydraulicUpper = {};
        self.rotationPartHydraulicUpper.node = rotationPartNodeHydraulicUpper;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartHydraulicUpper#minRot"));
        self.rotationPartHydraulicUpper.minRot = {};
        self.rotationPartHydraulicUpper.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartHydraulicUpper.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartHydraulicUpper.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartHydraulicUpper#maxRot"));
        self.rotationPartHydraulicUpper.maxRot = {};
        self.rotationPartHydraulicUpper.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartHydraulicUpper.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartHydraulicUpper.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartHydraulicUpper.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartHydraulicUpper#rotTime"), 2)*1000;
        self.rotationPartHydraulicUpper.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.rotationPartHydraulicUpper#touchRotLimit"), 10));
    end;
end;

function hours_schlepper:getSaveAttributesAndNodes(nodeIdent)
    local attributes, nodes;
    local modStr = 'std="'..self.std..'"';
    if attributes == nil then
        attributes = modStr;
    else
        attributes = attributes .. " "..modStr;
    end;
    return attributes, nodes;
end;

function hours_schlepper:loadFromAttributesAndNodes(xmlFile, key, resetVehicles)

    if not resetVehicles then
        local std = getXMLFloat(xmlFile, key.."#std");
        if std ~= nil then
            self:setstd(std);
        end;
    end;
    return BaseMission.VEHICLE_LOAD_OK;
end;

function hours_schlepper:keyEvent(unicode, sym, modifier, isDown)
	if sym == Input.KEY_k then
		self.translationMinMain = isDown;
	end;
	if sym == Input.KEY_m then
		self.translationMaxMain = isDown;
	end;
end;

function hours_schlepper:update(dt)
	--[[if self.fillLevel == 0 or self.currentFillType == 0 then
		self:setIsTurnedOn(false)
	elseif self.isTurnedOn and self.speedViolationTimer > 0 and self.fillLevel ~= 0 and self.currentFillType ~= 0 then
		local difficultyMultiplier = math.max(3 * (3 - g_currentMission.missionStats.difficulty), 1);
		local deltaLevel = FruitUtil.fruitIndexToDesc[self.currentFillType].literPerQm * difficultyMultiplier * self.dischargeSpeed;
		self:setFillLevel(self.fillLevel-deltaLevel, self.currentFillType);
	end; ]]

	local doTranslate = self.translationMaxMain or self.translationMinMain;
	if self.translationMaxMain ~= nil and doTranslate then
		local x, y, z = getTranslation(self.translationPartMain.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartMain.maxTrans, self.translationPartMain.minTrans, 3, self.translationPartMain.transTime, dt, not self.translationMaxMain);
		setTranslation(self.translationPartMain.node, unpack(newTrans));
		
		local x, y, z = getTranslation(self.translationPartLeft.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartLeft.maxTrans, self.translationPartLeft.minTrans, 3, self.translationPartLeft.transTime, dt, not self.translationMaxMain);
		setTranslation(self.translationPartLeft.node, unpack(newTrans));
		
		local x, y, z = getTranslation(self.translationPartRight.node);
		local trans = {x,y,z};
		local newTrans = Utils.getMovedLimitedValues(trans, self.translationPartRight.maxTrans, self.translationPartRight.minTrans, 3, self.translationPartRight.transTime, dt, not self.translationMaxMain);
		setTranslation(self.translationPartRight.node, unpack(newTrans));
		
		local x, y, z = getRotation(self.rotationPartHydraulicUpper.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartHydraulicUpper.maxRot, self.rotationPartHydraulicUpper.minRot, 3, self.rotationPartHydraulicUpper.rotTime, dt, not self.translationMaxMain);
		setRotation(self.rotationPartHydraulicUpper.node, unpack(newRot));

		local x, y, z = getRotation(self.rotationPartHydraulicLower.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartHydraulicLower.maxRot, self.rotationPartHydraulicLower.minRot, 3, self.rotationPartHydraulicLower.rotTime, dt, not self.translationMaxMain);
		setRotation(self.rotationPartHydraulicLower.node, unpack(newRot));
	end;
	
    if self.isEntered or self.isHired then 
		local time = (g_currentMission.environment.dayTime/(3600000000000/g_settingsTimeScale));
		self:setstd(self.std + time);
	end;
	for i=1, 4 do
		if self.wheelArea[i] ~= nil then
			local x,y,z = getWorldTranslation(self.wheelArea[i].start);
			local x1,y1,z1 = getWorldTranslation(self.wheelArea[i].width);
			local x2,y2,z2 = getWorldTranslation(self.wheelArea[i].height);
			for a=0, 15 do			
				Utils.updateFruitCutShortArea(a, x, z, x1, z1, x2, z2, 1);
				Utils.cutFruitArea(a, x, z, x1, z1, x2, z2);
				Utils.updateFruitWindrowArea(a, x, z, x1, z1, x2, z2, 1, true);
				Utils.updateFruitWindrowArea(a, x, z, x1, z1, x2, z2, 0)
			end;
			
		end;
	end;

end;

function hours_schlepper:draw()
	setTextBold(true);
	renderText(self.hudBasePoxX, self.hudBasePoxY+0.185, 0.021, string.format("%s%d" , "Betriebs(h):", self.std));
	setTextBold(false);
end;

function hours_schlepper:onEnter()
end;

function hours_schlepper:onLeave()
end;

function hours_schlepper:delete()
end;

function hours_schlepper:mouseEvent(posX, posY, isDown, isUp, button)
end;

function hours_schlepper:setstd(newstd)
    self.std = math.max(math.min(newstd, self.stdh), 0);
end;






